# ------------------------------------------------------------------------
#
#	genMetaSrcMin.pl
#
# Notes:
#	- generate MetaFilesSrcMin.min
#
#	Date			  Name		Vers		Change
#	----------	 ------ 	----	-------------------------------
#	2006-05-19	  ougq	  1.0	Init Version
# ------------------------------------------------------------------------
#
# s ͷʾ
# a ͷʾ
# h ͷʾϣ

use strict;
use Cwd;
use File::Basename;

my (@aSrcFiles,$sSrcFiles);
my $sSrcFile;
my (%hSrcFilePaths,$sSrcFilePath);
my (@allcfgs,$allcfgs,$cfg);
my $isoption;
my ($symbol_plus,$symbol_front_bracket,$symbol_back_bracket,$sourcefiles,$options);
#my $allfiles;

# ----------- Main ---------- 

#get the current directory
#$curpath = cwd;
#$curpath =~s/\/Arm\/ms//g; 

# Get enter param
my ($sInputFilePath, $sCfgFilePath)= @ARGV;

# Read input file to hash:aSrcFiles
open(FH,$sInputFilePath)||die "$!\n";
while(<FH>)
{
		chomp;
		$sSrcFiles = $sSrcFiles.$_." ";
}
close(FH);

open(FH,$sCfgFilePath)||die "$!\n";
while(<FH>)
{
	chomp;
	$allcfgs = $allcfgs.$_;
}
close(FH);
@allcfgs = split(/ /,$allcfgs);


@aSrcFiles = split(/ /,$sSrcFiles);


print "#--------------------------------------------------------------\n";
print "#															  \n";
print "#		   MetaFilesSrcMin.min								   \n";
print "#															  \n";
print "# This file is gererated automatically during building process.\n";
print "#--------------------------------------------------------------\n";
print "\n";
print "\n";



if(@aSrcFiles)
{
		print "META_SOURCE_FILES =	\\\n";
	
		foreach $sSrcFile (@aSrcFiles)
		{
				my $sFileName = basename($sSrcFile);
				print " 	   $sFileName \\\n";
				if(!exists $hSrcFilePaths{dirname($sSrcFile)})
				{
						$hSrcFilePaths{dirname($sSrcFile)}=1;
				}
		}
		print "\n\n";
	
		print "META_AUTO_OBJS := \$(addprefix \$(TARGETDIR)/, \$(META_SOURCE_FILES:%.c=%.o))\n";
					print "\$(META_AUTO_OBJS): APPFLAGS = -DBREW_STATIC_APP -DAEE_STATIC\n";
		print "\n\n";
}

foreach $sSrcFilePath (keys %hSrcFilePaths)
{
	print "vpath %.c $sSrcFilePath\n";
}
print "\n";
print "\n";


# Begin for framework.porting 
#my (@mfxfiles) = ();

# ---------------  mif ļ⴦ --------------------------------------------------------------------
#open(FH,"../../Meta/Mif/Mif.cfg")||die "$!\n";
#print "CONSTFILE_FILES+= \\\n";
#while(<FH>)
#{
#		chomp;
#		if((not /^$/) and (not /^#/)and (not/^\[/))
#		{
#		      # add by shaozw to do special process to mfx file
#			if(/\.mfx$/i) # whether it's a mif script
#			{
#				
#				#push @mfxfiles, $_;
#				~s/mfx$/mif/i;
#			}
#			
#	   		my $sFileName = basename($_);
#	   		print "		  $sFileName|fs:/mif/$sFileName \\\n";
#		}
#}

#print "\n\n";
#print "vpath %.mif ../../Meta/Mif";
#print "\n\n";

#my $BREWRCPATH = "../../../../QCTool/ResourceEditor";
# instructs how to compile mfx file
#foreach(@mfxfiles)
#{
#	my $mfxname = basename($_);
#	my $mifname = $mfxname;
#	$mifname =~ s/mfx$/mif/i;
	
#	print "$mifname : $mfxname\n";
#	print "\t$BREWRCPATH/brewrc.exe -o ../Meta/Mif/\$@ -i mif \$<\n";
#}
#print "\n\n";

#print "vpath %.mfx ../../Meta/Mif\n\n";
# End for framework.porting

# ------------- 
close(FH);
print "\n";
print "\n";



print "\n";
print "\n";
# --------------------------------------------------------------------------------------------------------
print "#--------------------------------------------------------\n";
print "#\n";
print "# sourcefiles_options\n";
print "#\n";
print "#--------------------------------------------------------\n";
if(@allcfgs)
{
	foreach $cfg (@allcfgs)
	{
		#$cfg =~s/\.\.\/\.\./$curpath/g;
		$isoption = 0;
	
		open(FH,"$cfg")||die "$!\n";
		while(<FH>)
		{
			chomp;
			if(/\[SourceFiles\_Options\]/i)
			{
				$isoption = 1;
				next;
			}
			if((/\[IncludeFiles\]/i) or (/\[SourceFiles\]/i) or (/\[LinkFiles\]/i) or (/\[Modules\]/i))
			{
				$isoption = 0;
				next;
			}
			if(($isoption == 1) and (not /^$/) and (not /^#/))
			{
				if(/^!/)
				{
					$_=substr($_,1);
					print "$_\n";
				}
				elsif((/all(\s|\t)*=/i) or (/arm(\s|\t)*=/i))
				{
					$symbol_plus = index($_,"+");
					$symbol_front_bracket = index($_,"(",$symbol_plus);
					$symbol_back_bracket = rindex($_,")");
					$sourcefiles = substr($_,0,$symbol_plus);

					$options = substr($_,$symbol_front_bracket+1,$symbol_back_bracket-$symbol_front_bracket-1);
					
					$sourcefiles =~ s/\$\(METAMMI\)/\.\.\/Meta/g;
					
					if($sourcefiles =~ m/\*/)
					{
						print "\$\(patsubst \%\.c,\$\(TARGETDIR\)\/\%\.o, \\\n";
						
						$sourcefiles = dirname($sourcefiles);
						foreach (@aSrcFiles)
						{
							if(/$sourcefiles/i)
							{
								my $src = basename($_);
								print "                           $src \\\n";
							}
						}
						print "                           \)\\\n";
					}
					else
					{
						$sourcefiles = basename($sourcefiles);
						print "\$\(patsubst \%\.c,\$\(TARGETDIR\)\/\%\.o,$sourcefiles\)\\\n";
					}
					print " : APPFLAGS += $options\n";
				}
			}
		}
	}
}
print "\n";


exit;

