#-------------------------------------------------------------------------------
#
#					gendsp.mak
#
#			generate Simulator.dsp.
#-------------------------------------------------------------------------------
#   Date			  Name		Vers		Change
#	----------	 ------		----	--------------------------------------------------
#	2006-04-03    tanrw	   1.0   Init Version
# 2006-04-11		tanrw		 1.1	 Split all incs & srcs to several parts,
#																	 as arument list too long for shell command.
#-------------------------------------------------------------------------------
all:genfilepath
#-------------------------------------------------------------------------------
# Path to ARM 1.2 tools
#-------------------------------------------------------------------------------
ARMHOME = $(ARM12HOME)
ARMHOME := $(subst \,/,$(ARMHOME))

#-------------------------------------------------------------------------------
#
#-------------------------------------------------------------------------------
METAMMI=../../source/Meta
METAMMISTR=METAMMI
META_TARGET=Win32

-include MetaCfg.min

#-------------------------------------------------------------------------------
# Generate all include and source files' path.
#-------------------------------------------------------------------------------
genfilepath: $(METACFG)
	@echo ------------------------------------------------------------------------
	@echo Generating file paths...
	@echo $^ >cfgfiles.txt
	@perl genfilepath.pl $(METAMMI) $(METAMMISTR)>MetaFile.min
	@echo ------------------------------------------------------------------------


-include MetaFile.min	
#-------------------------------------------------------------------------------
# Generate Simulator.dsp
#-------------------------------------------------------------------------------
dsp:dspinc dspsrc dsplib dspall

dspinc:dspappsinc dspcommoninc dspsysteminc dsputkinc dsp3partsinc
dspappsinc: $(META_APPS_INCS)
	@echo $^ >includefiles.txt
dspcommoninc: $(META_COMMON_INCS)
	@echo $^ >>includefiles.txt
dspsysteminc: $(META_SYSTEM_INCS)
	@echo $^ >>includefiles.txt
dsputkinc: $(META_UTK_INCS)
	@echo $^ >>includefiles.txt
dsp3partsinc: $(META_3PARTS_INCS) $(META_INCS)
	@echo $^ >>includefiles.txt

dspsrc:dspappssrc dspcommonsrc dspsystemsrc dsputksrc dsp3partssrc
dspappssrc: $(META_APPS_SRCS)
	@echo $^ >sourcefiles.txt
dspcommonsrc: $(META_COMMON_SRCS)
	@echo $^ >>sourcefiles.txt
dspsystemsrc: $(META_SYSTEM_SRCS)
	@echo $^ >>sourcefiles.txt
dsputksrc: $(META_UTK_SRCS)
	@echo $^ >>sourcefiles.txt
dsp3partssrc: $(META_3PARTS_SRCS) $(META_SRCS)
	@echo $^ >>sourcefiles.txt

dsplib: $(META_LIBS)
	@echo $^ >libraryfiles.txt
dspall:
	@echo ------------------------------------------------------------------------
	@echo Generating Simulator.dsp...
	@perl gendsp.pl >Simulator.dsp
	@echo ------------------------------------------------------------------------
	
copyincfile:
	@echo ------------------------------------------------------------------------
	@perl inc_files_copy.pl inc
	@echo copy completed >copy.log
	
